package view;
import java.awt.*;
import javax.swing.*;
import control.*;
import model.*;
/**
 * @author SELVAGGIO GIANLUCA
 * @version 1.0 
 * MAIN SOFTWARE PANEL
 * 
 * 
 */
public class SearchPage  extends JFrame implements FindEventListener{
	
	private static final long serialVersionUID = 1L;
	private JTextField codPart,description;
	private TextArea	sequence;
	private JLabel		cod,descr,seq,type;
	private JButton	   go,newSearch;
	private JPanel	   mainpanel;
	private JMenuBar   button;
	private Choice	typePart;
	private Buffer 	   buffer;
	private AgentFind agent;
	private Cursor mouse;
	
	public SearchPage(Buffer b){
		super("ARQ SEARCH FORM");
		setSize(950,550);
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);//close on X
		//GUI
		mainpanel=new JPanel();
		button=new JMenuBar();
		cod=new JLabel("CODE PARTS");
		descr=new JLabel("PARTIAL DESCRIPTION");
		seq=new JLabel("SEQUENCE");
		type=new JLabel("PART TYPE");
		go=new JButton("GO!");
		newSearch=new JButton("START NEW SEARCH");
		codPart=new JTextField(10);
		description=new JTextField(30);
		typePart=new Choice();
		typePart.add("Measurement");
		typePart.add("generator");
		typePart.add("composite");
		typePart.add("rna");
		typePart.add("dna");
		typePart.add("conjugation");
		typePart.add("reporter");
		typePart.add("signalling");
		typePart.add("RBS");
		typePart.add("regulatory");
		typePart.add("terminator");
		typePart.add("All");
		typePart.select(typePart.getItemCount()-1);
		sequence=new TextArea("",10,10 );
        sequence.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
       	button.setLayout(new BoxLayout(button, BoxLayout.X_AXIS));
		button.add(go);
		button.add(Box.createHorizontalStrut(5));
		button.add(newSearch);
		mainpanel.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.gridx=0;
		c.gridy=0;
		mainpanel.add(cod,c);
		c.insets = new Insets(0,10,0,0);  
		c.gridx=1;
		mainpanel.add(descr,c);
		c.gridx=2;
		mainpanel.add(type,c);
		c.gridy=1;
		c.gridx=0;
		mainpanel.add(codPart, c);
		c.gridx=1;
		mainpanel.add(description, c);
		c.weightx=0.5;
		c.insets = new Insets(0,20,0,0);  
		c.gridx=2;
		mainpanel.add(typePart, c);
		c.gridx=1;
		c.gridy=2;
		mainpanel.add(seq, c);
		c.gridy=3;
		c.gridx=1;
		c.fill = GridBagConstraints.HORIZONTAL;
		mainpanel.add(sequence, c);
		c.gridy=4;
		c.gridx=1;
		c.fill=GridBagConstraints.CENTER;
		c.insets = new Insets(20,25,0,0); 
		mainpanel.add(button,c);
		add(mainpanel);
		pack();
		//agents buffer
		buffer=b;
		buffer.addListener(this);
		agent=new AgentFind(buffer);
		agent.start();
		//Listener
		go.addActionListener(new ListenerGo(this,buffer,agent,go,codPart,description,sequence,typePart));
		newSearch.addActionListener(new ListenerReset(this,agent));
		
		
		
		
		
		
	}
	/**
	 * CLEAR ALL TEXTFILED AN SELECT THE OPTION ALL IN THE DROP DOWN MENU'
	 */
	public void clearAll(){
		
		this.setCursor(mouse.DEFAULT_CURSOR);
		codPart.setText(null);
		codPart.setEditable(true);
		description.setText(null);
		description.setEditable(true);
		typePart.select(typePart.getItemCount()-1);
		typePart.setEnabled(true);
		sequence.setText(null);
		sequence.setEditable(true);
		go.setEnabled(true);
	}
	
	/**
	 * RETURN THE STRING WHICH IS CONTAINED IN THE CODE PARTS TEXTFIELD
	 */
	public String returnCodPart(){
		
		return codPart.getText();
	}
	/**
	 * RETURN THE STRING WHICH IS CONTAINED IN THE PARTIAL DESCRIPTION TEXT FIELD
	 */
	public String returnDescription(){
		
		return description.getText();
	}
	/**
	 * RETURN A STRING[] WHICH CONTAINS THE SELECTED TYPE PARTS
	 */
	public String[] returnTypePart(){
		
		String[] a=new String[typePart.getItemCount()-1];
		if(typePart.getSelectedItem()=="All"){
			for(int i=0;i<a.length;i++){
				a[i]=typePart.getItem(i);
			}
			return a;
		}else{
			a[0]=typePart.getSelectedItem();
			return a;
		}
	}
	/**
	 * RETURN THE STRING WHICH IS CONTAINED IN THE SEQUENCE TEXTAREA
	 */
	public String returnSequence(){
		
		return sequence.getText();
	}
	/**
	 * SET THE TEXTFIELD CODE PARTS WITH STHE STRING ST AND SET IT NON EDITABLE
	 */
	public void setCodPart(String st){
		
		codPart.setText(st);
		codPart.setEditable(false);
	}
	/**
	 * SET THE TEXTFIELD PARTIAL DESCRIPTION WITH STHE STRING ST AND SET IT NON EDITABLE
	 */
	public void setDescription(String st){
		
		description.setText(st);
		description.setEditable(false);
	}
	
	
	/**
	 * SET THE TEXTFIELD SEQUENCE WITH STHE STRING ST AND SET IT NON EDITABLE
	 */
	public void setSequence(String st){
		
		sequence.setText(st);
		sequence.setEditable(false);
	}
	/**
	 * CALL THE SETTEXTFIELD CODEPARTS,SEQUENCE,PARTIAL DESCRIPTION AND FILL THOSE WITH THE STRING WHICH CAME FROM BUFFER 
	 */
	public void findString(FindEvent ev){
		
		if(ev.getOutputString()=="sequence"){
			setSequence(ev.getStringEvent());
		}
		if(ev.getOutputString()=="description"){
			setDescription(ev.getStringEvent());
			
		}
		if(ev.getOutputString()=="codPart"){
			setCodPart(ev.getStringEvent());
			
		}
		this.setCursor(mouse.DEFAULT_CURSOR);
	}

}
